<?php

namespace src\dto;

#[\AllowDynamicProperties]
class BaseDTO
{
    public int $id;

    public function fillable(): array
    {
        return [];
    }

    public function load(array $array): void
    {
        if (is_array($array)) {
            foreach ($array as $key => $value) {
                $this->{$key} = $value;
            }
        }
    }

    public function toString(): string
    {
        return implode(";", $this->fillable());
    }

    /**
     * @param string $key
     * @return string|null
     */
    public function getByKey(string $key): ?string
    {
        if (isset($this->{$key})) {
            return $this->{$key};
        }

        return null;
    }

}